"""
 id: install_flashfiles
 title: Install FlashFiles *optional*
 module name: CMFFlashFile.Install
 function name: install
"""

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFFlashFile import FlashFile, flashfile_globals
from cStringIO import StringIO
import string

def install(self):
    """register the CMF flashfile content"""
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    metadatatool = getToolByName(self, 'portal_metadata')
    catalog = getToolByName(self, 'portal_catalog')
    c_catalog = catalog._catalog
    
##     # : Uncomment to add indexes & columns


##     try:
##         c_catalog.addIndex( 'field1', 'FieldIndex' )
##     except:
##         pass

##     try:
##         c_catalog.addColumn( 'field1' )
##     except:
##         pass

        


    # setup typetool
    for t in FlashFile.factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)

    try:
        metadatatool.addElementPolicy(element='Subject',
                                      content_type='FlashFile',
                                      is_required=0,
                                      supply_default=0,
                                      default_value='',
                                      enforce_vocabulary=0,
                                      allowed_vocabulary=(),
                                      REQUEST=None)
    except:
        print 'Cannot add element policy'

        
    # setup skins
    if 'flashfile' not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', flashfile_globals)

    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map( string.strip, string.split(path, ','))
        if 'flashfile' not in path:
            try: path.insert(path.index('content'), 'flashfile')
            except ValueError:
                path.append('flashfile')

            path = string.join(path, ', ')
            skinstool.addSkinSelection(skin, path)

    return 'OK'

