from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.File import File
from DateTime import DateTime

from Products.CMFCore import CMFCorePermissions

factory_type_information = (
    {'id': 'FlashFile',
     'content_icon': 'flashfile_icon.gif',
     'meta_type': 'CMF FlashFile',
     'description': 'a simple flashfile product for CMF',
     'product': 'CMFFlashFile',
     'factory': 'addFlashFile',
     'immediate_view': 'flashfile_edit_form',
     'actions': ({ 'id': 'view',
                   'name': 'View',
                   'action': 'flashfile_view',
                   'permissions': (CMFCorePermissions.View,) },
                 { 'id': 'edit',
                   'name': 'Edit',
                   'action': 'flashfile_edit_form',
                   'permissions': CMFCorePermissions.ModifyPortalContent},
                )
     },
   )

def addFlashFile(self, id, title='', description='', REQUEST=None):
    """object manager constructor"""
    o = FlashFile(id, title, description)
    self._setObject(id, o)
    

class FlashFile(File):

    meta_type = 'CMF FlashFile'

    security = ClassSecurityInfo()
    security.declareObjectProtected(CMFCorePermissions.View)
    
    def __init__(self, id, title='', description='', height='', width=''):
        self.id = id
        self.setTitle(title)
        self.setDescription(description)
        self.height = height
        self.width = width
        
    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'edit')
    def edit(self, precondition='', file='', height='', width=''):
        """ Update and reindex. """
        self._edit(precondition, file)
        self.height = height
        self.width = width
        self.reindexObject()


InitializeClass(FlashFile)
        

